Package org.springframework.web.bind.annotation

# Enum Class RequestMethod

java.lang.Object
java.lang.Enum<RequestMethod>
org.springframework.web.bind.annotation.RequestMethod

All Implemented Interfaces:
  `Serializable`, `Comparable<RequestMethod>`, `Constable`

public enum RequestMethod extends Enum<RequestMethod>
Enumeration of HTTP request methods. Intended for use with the `RequestMapping.method()` attribute of the `RequestMapping` annotation.

Note that, by default, `org.springframework.web.servlet.DispatcherServlet` supports GET, HEAD, POST, PUT, PATCH, and DELETE only. DispatcherServlet will process TRACE and OPTIONS with the default HttpServlet behavior unless explicitly told to dispatch those request types as well: Check out the "dispatchOptionsRequest" and "dispatchTraceRequest" properties, switching them to "true" if necessary.

Since:
  2.5
Author:
  Juergen Hoeller
See Also:
  - `RequestMapping`
  - `org.springframework.web.servlet.DispatcherServlet#setDispatchOptionsRequest`
  - `org.springframework.web.servlet.DispatcherServlet#setDispatchTraceRequest`

## Nested Class Summary

## Nested classes/interfaces inherited from class java.lang.Enum

`Enum.EnumDesc<E extends Enum<E>>`

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`DELETE`
`GET`
`HEAD`
`OPTIONS`
`PATCH`
`POST`
`PUT`
`TRACE`

## Method Summary

Modifier and Type
Method
Description
`HttpMethod`
`asHttpMethod()`
Return the `HttpMethod` corresponding to this `RequestMethod`.
`static RequestMethod`
`resolve(String method)`
Resolve the given method value to an `RequestMethod` enum value.
`static RequestMethod`
`resolve(HttpMethod httpMethod)`
Resolve the given `HttpMethod` to a `RequestMethod` enum value.
`static RequestMethod`
`valueOf(String name)`
Returns the enum constant of this class with the specified name.
`static RequestMethod[]`
`values()`
Returns an array containing the constants of this enum class, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### GET

public static final RequestMethod GET

### HEAD

public static final RequestMethod HEAD

### POST

public static final RequestMethod POST

### PUT

public static final RequestMethod PUT

### PATCH

public static final RequestMethod PATCH

### DELETE

public static final RequestMethod DELETE

### OPTIONS

public static final RequestMethod OPTIONS

### TRACE

public static final RequestMethod TRACE

## Method Details

### values

public static RequestMethod[] values()
Returns an array containing the constants of this enum class, in the order they are declared.

Returns:
  an array containing the constants of this enum class, in the order they are declared

### valueOf

public static RequestMethod valueOf(String name)
Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum class has no constant with the specified name
  `NullPointerException` - if the argument is null

### resolve

@Nullable public static RequestMethod resolve(String method)
Resolve the given method value to an `RequestMethod` enum value. Returns `null` if `method` has no corresponding value.

Parameters:
  `method` - the method value as a String
Returns:
  the corresponding `RequestMethod`, or `null` if not found
Since:
  6.0.6

### resolve

@Nullable public static RequestMethod resolve(HttpMethod httpMethod)
Resolve the given `HttpMethod` to a `RequestMethod` enum value. Returns `null` if `httpMethod` has no corresponding value.

Parameters:
  `httpMethod` - the http method object
Returns:
  the corresponding `RequestMethod`, or `null` if not found
Since:
  6.0.6

### asHttpMethod

public HttpMethod asHttpMethod()
Return the `HttpMethod` corresponding to this `RequestMethod`.

Returns:
  the http method for this request method
Since:
  6.0.6